<?php

// Works well with php5.3 and php5.6.

namespace Moduyun\Sms;

require_once('SmsSenderUtil.php');

class SmsSingleSender {
    var $url;
    var $accesskey;
    var $secretkey;
    var $util;

    function __construct($accesskey, $secretkey) {

        $this->accesskey =  $accesskey;
        $this->secretkey = $secretkey;
        $this->util = new SmsSenderUtil();
    }

    
    /**
     * 指定模板单发
     * @param string $nationCode 国家码，如 86 为中国
     * @param string $phoneNumber 不带国家码的手机号
     * @param int $templId 模板 id
     * @param array $params 模板参数列表，如模板 {1}...{2}...{3}，那么需要带三个参数
     * @param string $sign 签名，如果填空串，系统会使用默认签名
     * @param string $extend 扩展码，可填空串
     * @param string $ext 服务端原样返回的参数，可填空串
     * @return string json string { "result": xxxxx, "errmsg": "xxxxxx"  ... }，被省略的内容参见协议文档
     */
    function sendWithParam($nationCode, $phoneNumber, $templId , $params, $sign = "", $extend = "", $ext = "") {
      //live.sms.modoyun.com
        $this->url = "https://live2.moduyun.com/sms/v2/sendsinglesms";
        $random = $this->util->getRandom();
        $curTime = time();
        $wholeUrl = $this->url . "?accesskey=" . $this->accesskey . "&random=" . $random;

        // 按照协议组织 post 包体
        $data = new \stdClass();
        $tel = new \stdClass();
        $tel->nationcode = "".$nationCode;
        $tel->mobile = "".$phoneNumber;

        $data->tel = $tel;
        $data->sig = hash("sha256",
            "secretkey=".$this->secretkey."&random=".$random."&time=".$curTime."&mobile=".$phoneNumber, FALSE);
        $data->templateId = $templId;
        $data->parameter = $params;
        $data->signId = $sign;
        $data->time = $curTime;
        $data->extend = $extend;
        $data->ext = $ext;

        return $this->util->sendCurlPost($wholeUrl, $data);
    }
}

